﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ServiceModel;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.Configuration;
using System.Runtime.Serialization;

namespace RepositoryService
{
    public class UnityInstanceExtension : IExtension<InstanceContext>
    {
        private IUnityContainer container;

        public UnityInstanceExtension()
        {
            container = new UnityContainer();
            container.LoadConfiguration();
        }

        public void Attach(InstanceContext owner) { }
        public void Detach(InstanceContext owner) { }

        [DataMember]
        public IUnityContainer UnityContainer { get { return container; } }


    }
}