﻿using Microsoft.Practices.EnterpriseLibrary.Data;
using System.Data.Common;
using System.Data;
using Entities;


namespace RepositoryDatabase
{
    public class StudentParameterMapper  : IParameterMapper
    {
        public void AssignParameters(DbCommand command, object[] parameterValues)
        {
            Student s = parameterValues[0] as Student;
            if (s == null)
            {
                return;
            }

            DbParameter parameter = command.CreateParameter();
            parameter.ParameterName = "@Name";
            parameter.Size = 50;
            parameter.DbType = DbType.String;
            parameter.Value = s.Name;

            command.Parameters.Add(parameter);


            parameter = command.CreateParameter();
            parameter.ParameterName = "@Age";
            parameter.Size = 50;

            parameter.DbType = DbType.String;

            parameter.Value = s.Age;

            command.Parameters.Add(parameter);

            parameter = command.CreateParameter();
            parameter.ParameterName = "@Address";
            parameter.Size = 50;

            parameter.DbType = DbType.String;

            parameter.Value = s.Address;

            command.Parameters.Add(parameter);


            //command.Parameters.Add(
           // command.Parameters.Add(new DbParameter("@CategoryName", "Beverages"));
            //command.Parameters.Add(new DbParameter("@CategoryName", "Beverages"));


        }
    }
}
