﻿using Microsoft.Practices.EnterpriseLibrary.Data;
using Entities;

namespace RepositoryDatabase
{
    public class StudentRowMapper : IRowMapper<Student>
    {
        public Student MapRow(System.Data.IDataRecord row)
        {
            Student student = new Student();
            student.Name = row.GetString(row.GetOrdinal("Name"));
            student.Age = row.GetString(row.GetOrdinal("Age"));
            student.Address = row.GetString(row.GetOrdinal("Address")); ;

            return student;
        }
    }


}
