﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using RepositoryDatabase;
using Entities;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Data;

namespace RepositoryService
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "Service1" in code, svc and config file together.
    [UnityBehaviour]
    public class DemoService : IDemoService
    {
        public void Insert(Student entity)
        {
            InstanceContext ic = OperationContext.Current.InstanceContext;

            IUnityContainer container = ic.Extensions.Find<UnityInstanceExtension>().UnityContainer;
           

            DataAccessor<Student> data = container.Resolve<DataAccessor<Student>>("StudentInsert");

            IRepository<Student> ob = new Repository<Student>(data);
             ob.Insert(entity);
        }

        public IEnumerable<Student> GetAll()
        {
            throw new NotImplementedException();
        }
    }
}
